# Contributing

This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](contributor-covenant.org) code of conduct.

We welcome any kind of contribution: Documentation, code, issues, discussions, critique, speaking about it...

This project follows the [Angular Conventional Commit guidelines](https://github.com/angular/angular.js/blob/master/CONTRIBUTING.md#-git-commit-guidelines). We require that every commit message follows these guidelines, Pull Requests not following this pattern will be rejected.

Unit tests live in the same file inside a [`tests`](https://doc.rust-lang.org/book/second-edition/ch11-01-writing-tests.html) module.
Integration tests are in `tests/`.

Please describe all new features with tests. Also please add [rustdoc](https://doc.rust-lang.org/1.6.0/book/documentation.html) for all public functions.
